/** @file  eomLapseRatios.h
 *  @brief The lapse factors BimetricEvolve::eq_gW and BimetricEvolve::eq_fW.
 */

Real BimetricEvolve::eq_gW( Int m, Int n )
{
    return (4 * fA(m,n) * gA(m,n) * Lt(m,n) * p(m,n) * pow2(gB(m,n)) * pow2(R(m,n)) 
    /*1*/  * r(m,n) * (fDB(m,n) * Lt(m,n) * pow2(gA(m,n)) * R(m,n) * (2 * (fK(m,n) 
    /*4*/  - fKD(m,n)) * pow2(P_1_1(R(m,n))) * R(m,n) + (gK(m,n) - gKD(m,n)) * Lt(m,n) 
    /*3*/  * (P_1_1(R(m,n)) * (2 * P_1_1(R(m,n)) + P_2_1(R(m,n))) + P_0_2(R(m,n)) 
    /*4*/  * P_2_1(R(m,n)) * R(m,n))) + fA(m,n) * gDB(m,n) * (-3 * P_1_2(R(m,n)) 
    /*3*/  * P_2_1(R(m,n)) * p_r(m,n) * R(m,n) + fA(m,n) * Lt(m,n) * (2 * Lt(m,n) 
    /*4*/  * P_1_2(R(m,n)) * (2 * (gK(m,n) - gKD(m,n)) * P_1_1(R(m,n)) + (gK(m,n) + 2 
    /*6*/  * gKD(m,n)) * P_2_1(R(m,n))) + (-(fKD(m,n) * P_0_2(R(m,n))) + 2 * (gK(m,n) 
    /*6*/  - gKD(m,n)) * Lt(m,n) * P_0_3(R(m,n)) + fK(m,n) * (P_0_2(R(m,n)) - 3 
    /*6*/  * P_1_2(R(m,n)))) * P_2_1(R(m,n)) * R(m,n))) + fA(m,n) * gA(m,n) * Lt(m,n) 
    /*2*/  * R(m,n) * (fDB(m,n) * (gK(m,n) - gKD(m,n)) * (-4 * P_1_1(R(m,n)) 
    /*4*/  * P_1_2(R(m,n)) + P_0_2(R(m,n)) * P_2_1(R(m,n))) - gDB(m,n) 
    /*3*/  * (-(P_1_2(R(m,n)) * (2 * (gK(m,n) - gKD(m,n)) * P_1_1(R(m,n)) + (gK(m,n) + 2
    /*7*/  * gKD(m,n)) * P_2_1(R(m,n)))) + (fK(m,n) - fKD(m,n)) * Lt(m,n) 
    /*4*/  * (P_1_1(R(m,n)) * (2 * P_1_1(R(m,n)) + P_2_1(R(m,n))) + P_0_2(R(m,n)) 
    /*5*/  * P_2_1(R(m,n)) * R(m,n)))))) / 3. + pow2(r(m,n)) * (k_g * gA(m,n) 
    /*1*/  * pow2(fA(m,n)) * pow2(Lt(m,n)) * pow2(R(m,n)) * P_2_1(R(m,n)) * (2 * fA(m,n)
    /*2*/  * (-pftau(m,n) + pfD(m,n) * (-1 + pow2(Lt(m,n))) + (-(pfS(m,n) * pfv(m,n))
    /*4*/  + pftau(m,n)) * pow2(Lt(m,n))) * P_1_2(R(m,n)) + 4 * fA(m,n) * pow2(p(m,n))
    /*2*/  * P_1_2(R(m,n)) * (-pfD(m,n) - pftau(m,n) + fA(m,n) * Lt(m,n) 
    /*3*/  * pow2(gB(m,n)) * P_2_1(R(m,n))) + 2 * Lt(m,n) * pow2(gA(m,n)) 
    /*2*/  * pow2(gB(m,n)) * (-2 * P_1_1(R(m,n)) * P_2_0(R(m,n)) + (-P_1_0(R(m,n)) 
    /*4*/  + P_2_0(R(m,n))) * P_2_1(R(m,n))) + gA(m,n) * (Lt(m,n) * (pfD(m,n) - pfS(m,n)
    /*4*/  * pfv(m,n) + pftau(m,n)) * (2 * P_1_1(R(m,n)) - P_2_1(R(m,n))) + fA(m,n) 
    /*3*/  * pow2(gB(m,n)) * (-2 * P_1_2(R(m,n)) * P_2_0(R(m,n)) + P_2_1(R(m,n)) * (-4 
    /*5*/  * P_1_1(R(m,n)) + P_2_1(R(m,n)))))) + k_f * pow2(fA(m,n)) * pow2(gA(m,n)) 
    /*1*/  * pow2(gB(m,n)) * pow2(Lt(m,n)) * P_2_1(R(m,n)) * (6 * gA(m,n) * Lt(m,n) 
    /*2*/  * P_1_1(R(m,n)) * P_2_1(R(m,n)) * R(m,n) + fA(m,n) * (P_2_1(R(m,n)) 
    /*3*/  * (P_2_1(R(m,n)) + 2 * P_1_2(R(m,n)) * R(m,n)) - 2 * P_1_1(R(m,n)) 
    /*3*/  * (P_2_1(R(m,n)) - P_2_2(R(m,n)) * R(m,n)))) + (2 * gA(m,n) * Lt(m,n) 
    /*2*/  * pow2(fA(m,n)) * pow2(gB(m,n)) * pow2(R(m,n)) * (-12 * fA(m,n) 
    /*3*/  * (-gKD_r(m,n) + gK_r(m,n)) * p(m,n) * pow2(Lt(m,n)) * P_1_2(R(m,n)) 
    /*3*/  * P_2_1(R(m,n)) - 2 * fA(m,n) * gA(m,n) * Lt(m,n) * pow2(gK(m,n) - gKD(m,n))
    /*3*/  * pow2(p(m,n)) * P_1_2(R(m,n)) * (2 * P_1_1(R(m,n)) + P_2_1(R(m,n))) + 2 
    /*3*/  * (fK(m,n) - fKD(m,n)) * Lt(m,n) * pow2(gA(m,n)) * pow2(p(m,n)) 
    /*3*/  * P_1_1(R(m,n)) * (2 * (gK(m,n) - gKD(m,n)) * P_1_1(R(m,n)) + (gK(m,n) + 2 
    /*5*/  * gKD(m,n)) * P_2_1(R(m,n))) * R(m,n) + pow2(gA(m,n)) * pow2(Lt(m,n)) 
    /*3*/  * P_2_1(R(m,n)) * (-2 * (fK(m,n) - fKD(m,n)) * (gK(m,n) + 2 * gKD(m,n)) 
    /*4*/  * Lt(m,n) * P_1_1(R(m,n)) * R(m,n) + pow2(gK(m,n) - gKD(m,n)) * (-4 
    /*5*/  * P_1_1(R(m,n)) + P_2_1(R(m,n)) - 2 * P_0_2(R(m,n)) * R(m,n)) + 2 * (gK(m,n)
    /*5*/  - gKD(m,n)) * R(m,n) * (-((gK(m,n) + 2 * gKD(m,n)) * P_1_2(R(m,n))) 
    /*5*/  + (fK(m,n) - fKD(m,n)) * Lt(m,n) * (P_1_1(R(m,n)) + P_0_2(R(m,n)) * R(m,n))))
    /*3*/  + gA(m,n) * P_2_1(R(m,n)) * (6 * ((fK(m,n) - fKD(m,n)) * P_1_1(R(m,n)) 
    /*5*/  + (gK(m,n) - gKD(m,n)) * Lt(m,n) * P_1_2(R(m,n))) * p_r(m,n) * R(m,n) 
    /*4*/  + fA(m,n) * Lt(m,n) * (3 * (fK(m,n) - fKD(m,n)) * (fK(m,n) + fKD(m,n)) 
    /*5*/  * P_1_1(R(m,n)) * R(m,n) + 2 * (gK(m,n) - gKD(m,n)) * Lt(m,n) * (fKD(m,n) 
    /*6*/  * P_0_2(R(m,n)) - fK(m,n) * (P_0_2(R(m,n)) - 3 * P_1_2(R(m,n)))) * R(m,n) 
    /*5*/  - pow2(gK(m,n) - gKD(m,n)) * (3 * P_1_2(R(m,n)) + 2 * pow2(Lt(m,n)) 
    /*6*/  * P_0_3(R(m,n)) * R(m,n)))))) / 9.) + 2 * pow2(Lt(m,n)) * R(m,n) * (4 
    /*1*/  * Lt(m,n) * pow2(fDB(m,n)) * pow2(gB(m,n)) * pow2(P_1_1(R(m,n))) 
    /*1*/  * pow3(gA(m,n)) * pow3(R(m,n)) + pow3(fA(m,n)) * (pow2(gA(m,n)) 
    /*2*/  * P_2_1(R(m,n)) * (P_1_1(R(m,n)) - P_1_2(R(m,n)) * R(m,n)) + pow2(gB(m,n)) 
    /*2*/  * pow2(gDB(m,n)) * R(m,n) * (-4 * pow2(Lt(m,n)) * P_1_1(R(m,n)) 
    /*3*/  * P_1_2(R(m,n)) + P_2_1(R(m,n)) * ((1 - 2 * pow2(p(m,n))) * P_1_2(R(m,n)) - 2
    /*4*/  * pow2(p(m,n)) * P_0_3(R(m,n)) * R(m,n)))) - fA(m,n) * fDB(m,n) 
    /*1*/  * pow2(gA(m,n)) * pow2(gB(m,n)) * pow2(R(m,n)) * (fDB(m,n) * (-2 
    /*3*/  * P_0_2(R(m,n)) * P_2_1(R(m,n)) * R(m,n) + P_1_1(R(m,n)) * (P_2_1(R(m,n)) + 4
    /*4*/  * P_1_2(R(m,n)) * R(m,n))) + 2 * gDB(m,n) * (-2 * P_1_1(R(m,n)) 
    /*3*/  * P_1_2(R(m,n)) * R(m,n) + pow2(Lt(m,n)) * (2 * pow2(P_1_1(R(m,n))) 
    /*4*/  + P_1_1(R(m,n)) * P_2_1(R(m,n)) + P_0_2(R(m,n)) * P_2_1(R(m,n)) * R(m,n)))) 
    /*1*/  + gA(m,n) * Lt(m,n) * pow2(fA(m,n)) * R(m,n) * (pow2(gA(m,n)) * P_2_1(R(m,n))
    /*2*/  * (-2 * P_1_1(R(m,n)) + P_2_1(R(m,n))) + gDB(m,n) * pow2(gB(m,n)) * (2 
    /*3*/  * fDB(m,n) * (4 * P_1_1(R(m,n)) * P_1_2(R(m,n)) - P_0_2(R(m,n)) 
    /*4*/  * P_2_1(R(m,n))) * R(m,n) + gDB(m,n) * (-(P_2_1(R(m,n)) * (P_2_1(R(m,n)) - 2
    /*6*/  * P_0_2(R(m,n)) * R(m,n))) + 4 * P_1_1(R(m,n)) * (P_2_1(R(m,n)) 
    /*5*/  - P_1_2(R(m,n)) * R(m,n))))));
}

Real BimetricEvolve::eq_fW( Int m, Int n )
{
    return (4 * fA(m,n) * gA(m,n) * Lt(m,n) * p(m,n) * pow2(gB(m,n)) * pow2(R(m,n)) 
    /*1*/  * r(m,n) * (-(gA(m,n) * (fA(m,n) * Lt(m,n) * ((fK(m,n) - fKD(m,n)) * gDB(m,n)
    /*5*/  * (4 * P_1_1(R(m,n)) * P_1_2(R(m,n)) - P_0_2(R(m,n)) * P_2_1(R(m,n))) 
    /*5*/  + fDB(m,n) * (2 * fKD(m,n) * P_1_1(R(m,n)) * P_1_2(R(m,n)) + fK(m,n) 
    /*6*/  * P_1_2(R(m,n)) * (-2 * P_1_1(R(m,n)) + 3 * P_2_1(R(m,n))) + (gK(m,n) 
    /*7*/  - gKD(m,n)) * Lt(m,n) * (2 * pow2(P_1_2(R(m,n))) - P_0_3(R(m,n)) 
    /*7*/  * P_2_1(R(m,n))))) + 3 * fDB(m,n) * P_1_2(R(m,n)) * P_2_1(R(m,n)) * p_r(m,n))
    /*3*/  * R(m,n)) + fDB(m,n) * Lt(m,n) * pow2(gA(m,n)) * R(m,n) * (((gK(m,n) 
    /*5*/  - gKD(m,n)) * P_0_2(R(m,n)) + 2 * (fK(m,n) + 2 * fKD(m,n)) * Lt(m,n) 
    /*4*/  * P_1_1(R(m,n)) + (gK(m,n) + 2 * gKD(m,n)) * P_1_2(R(m,n))) * P_2_1(R(m,n)) 
    /*3*/  - 2 * (fK(m,n) - fKD(m,n)) * Lt(m,n) * (pow2(P_1_1(R(m,n))) - P_1_1(R(m,n)) 
    /*4*/  * P_1_2(R(m,n)) * R(m,n) + P_0_2(R(m,n)) * P_2_1(R(m,n)) * R(m,n))) 
    /*2*/  - gDB(m,n) * Lt(m,n) * pow2(fA(m,n)) * (-2 * (gK(m,n) - gKD(m,n)) 
    /*3*/  * pow2(P_1_2(R(m,n))) + (fK(m,n) - fKD(m,n)) * Lt(m,n) * (2 * P_1_2(R(m,n)) 
    /*4*/  * (P_1_1(R(m,n)) - P_2_1(R(m,n))) + P_0_3(R(m,n)) * P_2_1(R(m,n)) 
    /*4*/  * R(m,n))))) / 3. + 2 * pow2(Lt(m,n)) * (Lt(m,n) * pow3(fA(m,n)) * (-4 
    /*2*/  * pow2(gB(m,n)) * pow2(gDB(m,n)) * pow2(P_1_2(R(m,n))) * pow2(R(m,n)) 
    /*2*/  + pow2(gA(m,n)) * P_2_1(R(m,n)) * (-P_1_1(R(m,n)) + P_1_2(R(m,n)) * R(m,n)))
    /*1*/  + pow2(fDB(m,n)) * pow2(gB(m,n)) * pow3(gA(m,n)) * pow3(R(m,n)) * (-2 
    /*2*/  * pow2(p(m,n)) * P_0_2(R(m,n)) * P_2_1(R(m,n)) * R(m,n) - P_1_1(R(m,n)) 
    /*2*/  * (P_2_1(R(m,n)) - 4 * pow2(Lt(m,n)) * P_1_2(R(m,n)) * R(m,n))) + fA(m,n) 
    /*1*/  * fDB(m,n) * Lt(m,n) * pow2(gA(m,n)) * pow2(gB(m,n)) * pow2(R(m,n)) * (-2 
    /*2*/  * gDB(m,n) * R(m,n) * (2 * P_1_1(R(m,n)) * P_1_2(R(m,n)) + P_1_2(R(m,n)) 
    /*3*/  * P_2_1(R(m,n)) - 2 * pow2(P_1_2(R(m,n))) * R(m,n) + P_0_3(R(m,n)) 
    /*3*/  * P_2_1(R(m,n)) * R(m,n)) + fDB(m,n) * (P_1_1(R(m,n)) * P_2_1(R(m,n)) 
    /*3*/  - R(m,n) * (P_1_2(R(m,n)) * P_2_1(R(m,n)) + 4 * pow2(P_1_2(R(m,n))) * R(m,n)
    /*4*/  - 2 * P_0_3(R(m,n)) * P_2_1(R(m,n)) * R(m,n)))) + gA(m,n) * pow2(fA(m,n)) 
    /*1*/  * R(m,n) * (pow2(gA(m,n)) * P_2_1(R(m,n)) * (P_1_1(R(m,n)) - P_1_2(R(m,n)) 
    /*3*/  * R(m,n)) + gDB(m,n) * pow2(gB(m,n)) * R(m,n) * (2 * fDB(m,n) * (2 * (2 
    /*5*/  + pow2(p(m,n))) * pow2(P_1_2(R(m,n))) - pow2(Lt(m,n)) * P_0_3(R(m,n)) 
    /*4*/  * P_2_1(R(m,n))) * R(m,n) + gDB(m,n) * (3 * P_1_2(R(m,n)) * P_2_1(R(m,n)) - 4
    /*4*/  * pow2(P_1_2(R(m,n))) * R(m,n) + 2 * P_0_3(R(m,n)) * P_2_1(R(m,n)) 
    /*4*/  * R(m,n))))) + pow2(r(m,n)) * (k_g * pow2(fA(m,n)) * pow2(gA(m,n)) 
    /*1*/  * pow2(Lt(m,n)) * pow2(R(m,n)) * P_2_1(R(m,n)) * (2 * P_1_2(R(m,n)) 
    /*2*/  * (pfD(m,n) + pftau(m,n) - 3 * fA(m,n) * Lt(m,n) * pow2(gB(m,n)) 
    /*3*/  * P_2_1(R(m,n))) + gA(m,n) * pow2(gB(m,n)) * (-2 * P_1_2(R(m,n)) 
    /*3*/  * P_2_0(R(m,n)) + P_2_1(R(m,n)) * (-4 * P_1_1(R(m,n)) + P_2_1(R(m,n))))) 
    /*1*/  + k_f * fA(m,n) * pow2(gA(m,n)) * pow2(gB(m,n)) * pow2(Lt(m,n)) 
    /*1*/  * P_2_1(R(m,n)) * (fA(m,n) * gA(m,n) * (-pow2(P_2_1(R(m,n))) + 4 
    /*3*/  * P_1_2(R(m,n)) * P_2_1(R(m,n)) * R(m,n) + 2 * P_1_1(R(m,n)) * P_2_2(R(m,n))
    /*3*/  * R(m,n)) + 2 * Lt(m,n) * pow2(fA(m,n)) * (-(P_1_1(R(m,n)) * P_2_2(R(m,n)))
    /*3*/  + (P_1_3(R(m,n)) * P_2_1(R(m,n)) + P_1_2(R(m,n)) * P_2_2(R(m,n))) * R(m,n))
    /*2*/  + 2 * gA(m,n) * pow2(p(m,n)) * P_2_1(R(m,n)) * (-2 * gA(m,n) * Lt(m,n) 
    /*3*/  * P_1_1(R(m,n)) * R(m,n) + fA(m,n) * (P_1_1(R(m,n)) - P_2_1(R(m,n)) 
    /*4*/  + P_1_2(R(m,n)) * R(m,n)))) + (2 * fA(m,n) * Lt(m,n) * pow2(gA(m,n)) 
    /*2*/  * pow2(gB(m,n)) * pow2(R(m,n)) * (2 * (gK(m,n) - gKD(m,n)) * Lt(m,n) 
    /*3*/  * pow2(fA(m,n)) * pow2(p(m,n)) * P_1_2(R(m,n)) * (-2 * fKD(m,n) 
    /*4*/  * P_1_1(R(m,n)) + fK(m,n) * (2 * P_1_1(R(m,n)) - 3 * P_2_1(R(m,n)))) - 12 
    /*3*/  * (-fKD_r(m,n) + fK_r(m,n)) * gA(m,n) * p(m,n) * pow2(Lt(m,n)) 
    /*3*/  * P_1_1(R(m,n)) * P_2_1(R(m,n)) * R(m,n) + 4 * fA(m,n) * gA(m,n) * Lt(m,n) 
    /*3*/  * pow2(fK(m,n) - fKD(m,n)) * pow2(p(m,n)) * P_1_1(R(m,n)) * (-P_1_1(R(m,n)) 
    /*4*/  + P_2_1(R(m,n))) * R(m,n) - fA(m,n) * gA(m,n) * Lt(m,n) * P_2_1(R(m,n)) * (3
    /*4*/  * pow2(gK(m,n)) * P_1_2(R(m,n)) - 3 * pow2(gKD(m,n)) * P_1_2(R(m,n)) + 2 
    /*4*/  * (fK(m,n) - fKD(m,n)) * gKD(m,n) * Lt(m,n) * (P_0_2(R(m,n)) - 2 
    /*5*/  * P_1_2(R(m,n))) * R(m,n) - 2 * (fK(m,n) - fKD(m,n)) * gK(m,n) * Lt(m,n) 
    /*4*/  * (P_0_2(R(m,n)) + P_1_2(R(m,n))) * R(m,n) + pow2(fK(m,n) - fKD(m,n)) 
    /*4*/  * R(m,n) * (-P_1_1(R(m,n)) + 2 * pow2(Lt(m,n)) * P_0_2(R(m,n)) * R(m,n))) 
    /*3*/  + fA(m,n) * P_2_1(R(m,n)) * (-6 * P_1_2(R(m,n)) * p_r(m,n) * (-gK(m,n) 
    /*5*/  + gKD(m,n) + (fK(m,n) - fKD(m,n)) * Lt(m,n) * R(m,n)) + fA(m,n) 
    /*4*/  * pow2(Lt(m,n)) * (-((fK(m,n) - 7 * fKD(m,n)) * (fK(m,n) - fKD(m,n)) 
    /*6*/  * P_1_1(R(m,n))) + 2 * (gK(m,n) - gKD(m,n)) * Lt(m,n) * ((fK(m,n) + 2 
    /*7*/  * fKD(m,n)) * P_1_2(R(m,n)) + (fK(m,n) - fKD(m,n)) * P_0_3(R(m,n)) * R(m,n))
    /*5*/  + (fK(m,n) - fKD(m,n)) * (fK(m,n) * (2 * P_0_2(R(m,n)) - 3 * P_1_2(R(m,n)))
    /*6*/  * R(m,n) + fKD(m,n) * (-6 * P_2_1(R(m,n)) + (-2 * P_0_2(R(m,n)) + 3 
    /*8*/  * P_1_2(R(m,n))) * R(m,n))))))) / 9.);
}

Real BimetricEvolve::eq_cW( Int m, Int n )
{
    return 2 * pow2(fA(m,n)) * pow2(gA(m,n)) * pow2(gB(m,n)) * pow2(r(m,n)) 
    /*0*/  * pow2(R(m,n)) * pow3(Lt(m,n)) * P_2_1(R(m,n));
}
